<?php
namespace Teknisa\Model\Teknisa\Repositories;

use Teknisa\Model\Traits\TQuery;

class Slacliente extends \Doctrine\ORM\EntityRepository {
    Use TQuery;

    public function findSlacliente($cdcliente)
    {
        $query = <<<SQL
            SELECT SC.CDCLIENTE, SC.CDGRUPFASE, SC.CDASSUNTO, SC.IDPRAZOSLA, SC.CDCOMPLEXID, 
                   CLA.LABEL AS CDASSUNTO_LABEL,
                   DECODE(SC.CDGRUPFASE, '13', 'Especificação', '30', 'Implementação') AS CDGRUPFASE_LABEL,
                   CASE
                       WHEN SC.CDGRUPFASE = '13' THEN 'Qtde. horas informada'
                       WHEN SC.IDPRAZOSLA = '1' THEN 'Qtde. horas informada'
                     ELSE 'Data entrega prevista'
                     END AS IDPRAZOSLA_LABEL,
                   DECODE(SC.QTDIASSLA, 0, '', SC.QTDIASSLA * 8) AS QTDIASSLA,
                   TO_CHAR(SC.DTINICIOSLA, 'DD/MM/YYYY') AS DTINICIOSLA
              FROM SLACLIENTE SC
              JOIN CLASSIFICATION CLA ON CLA.CDASSUNTO = SC.CDASSUNTO
             WHERE SC.IDATIVO = 'S'
             AND SC.CDCLIENTE = '$cdcliente'
             ORDER BY CDASSUNTO_LABEL
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->getEntityManager(), $query);
    }

}
